package march;

public class Vec{  
    public static final boolean DEBUG = false;
    public static final float TPI = (float)(Math.PI * 2.0);

    public float x,y,z;
  
    /* $B=i4|CM(B */
    public float ox,oy,oz; 
    
    /* $B=i4|>uBV$+$i$I$l$[$I2sE>$7$?$+(B */
    public float rot_x,rot_y,rot_z;
    
    /* xy$BJ?LL$KJ?9T$JJ?LL(B(z = vp)$B$KF);kEj1F$7$?$H$-$N:BI8$r5-21(B */
    /* $B;kE@$O(Bz$B<4>e(B( > vp )                   */
    public float px, py, pz;
    public boolean visible;

    public Vec(float x, float y, float z){
        this.x = x; this.y = y; this.z = z;
        ox = x; oy = y; oz = z;
        rot_x = 0.0f; rot_y = 0.0f; rot_z = 0.0f;
        if(DEBUG){
            System.err.println("new Vec = " + this.toString());
        }
   }

    public Vec(){
        this.x = 0.0f; this.y = 0.0f; this.z = 0.0f;
        ox = x; oy = y; oz = z;
        rot_x = 0.0f; rot_y = 0.0f; rot_z = 0.0f;
    }


    public String toString(){
        String ret = "Vec("+x+","+y+","+z+")";
        return ret;
    }

    public void returnToInit(){
        x = ox; y = oy; z = oz;
        rot_x = 0.0f; rot_y = 0.0f; rot_z = 0.0f;
    }
    
    public void setCurrentAsInit(){
        ox = x; oy = y; oz = z;
        rot_x = 0.0f; rot_y = 0.0f; rot_z = 0.0f;
    }
    
    public void translate(float tx, float ty, float tz){
        x += tx;
        y += ty;
        z += tz;
    }
    
    public void xAxisRotate(float r){
        rot_x += r;
        if(rot_x > TPI){
            rot_x -= TPI;
        }
        else if( rot_x < - TPI){
            rot_x += TPI;
        }
        rotateFromInit();
    }
    
    public void yAxisRotate(float r){
        rot_y += r;
        if(rot_y > TPI){
            rot_y -= TPI;
        }
        else if( rot_y < - TPI){
            rot_y += TPI;
        }
        rotateFromInit();
        
    }
    
    public void zAxisRotate(float r){
        rot_z += r;
        if(rot_z > TPI){
            rot_z -= TPI;
        }
        else if( rot_z < - TPI){
            rot_z += TPI;
        }
        rotateFromInit();
    }
    
    public void rotateFromInit(){
        float cosr = (float)Math.cos(rot_x);
        float sinr = (float)Math.sin(rot_x);
        float tx,ty,tz;
        
        x = ox;
        y = oy;
        z = oz;
        
        ty = y;
        tz = z;
        y = ty*cosr - tz*sinr;
        z = ty*sinr + tz*cosr;
        
        cosr = (float)Math.cos(rot_y);
        sinr = (float)Math.sin(rot_y);
        
        tz = z;
        tx = x;
        x = tz*sinr + tx*cosr;
        z = tz*cosr - tx*sinr;
        
        cosr = (float)Math.cos(rot_z);
        sinr = (float)Math.sin(rot_z);
        
        tx = x;
        ty = y;
        x = tx*cosr - ty*sinr;
        y = tx*sinr + ty*cosr;
        
    }
    
    /* $B;kE@$r(B (0,0,prp) prp > vp $B$K$*$$$F(B xy$BJ?LL$KJ?9T$JJ?LL(B(z = vp)
       $B$KF);kEj1F$7$?$H$-$N:BI8$r7W;;$7$F%;%C%H$9$k(B  */
    public void calcPerspectiveProjection(float vp, float prp){
        if( z >= vp ){
            visible = false;
        }
        else{
            visible = true;
        }
        
        float d = (prp - vp)/(prp - z);
        px = x*d;  
        py = y*d;
        pz = z*d;
    }
 
    /**
     * $BCm;kE@(B(fp)$B$r4^$`J?LL$X$NEj;qEj1F$7$?$H$-$N:BI8$r(B
     * $B7W;;$7$F%;%C%H$9$k!#;kE@$O(Bfp$B$+$i$N5wN%(BR, $BJ}0L3Q(Btheta, $B6D3Q(Bphi
     * $B$G<($9!#(B
     */
    public void calcPerspectiveProjection(Vec fp, 
                                          float R, float the, float phi){
        float st = (float)Math.sin(the);
        float ct = (float)Math.cos(the);
        float sp = (float)Math.sin(phi);
        float cp = (float)Math.cos(phi);
        calcPerspectiveProjection(fp, R, st, ct, sp, cp);
       
    }

    /**
     * $BCm;kE@(B(fp)$B$r4^$`J?LL$X$NEj;qEj1F$7$?$H$-$N:BI8$r(B
     * $B7W;;$7$F%;%C%H$9$k!#;kE@$O(Bfp$B$+$i$N5wN%(BR, $BJ}0L3Q(Btheta, $B6D3Q(Bphi
     * $B$G<($9!#(B
     */
    public void calcPerspectiveProjection(Vec fp, 
                                          float R,
                                          float sin_the,
                                          float cos_the,
                                          float sin_phi,
                                          float cos_phi){
        
        float xf = fp.x;
        float yf = fp.y;
        float zf = fp.z;
        float xd = (x - xf);
        float yd = (y - yf);
        float zd = (z - zf);
        float st = sin_the;
        float ct = cos_the;
        float sp = sin_phi;
        float cp = cos_phi;
        float xx = -xd*st+yd*ct;
        float yy = -xd*ct*sp-yd*st*sp+zd*cp;
        float zz = xd*ct*cp+yd*st*cp+zd*sp;
        if(zz >= R){
            visible = false;
        }
        else{
            visible = true;
        }
        float d = R/(R-zz);
        px = xx*d;
        py = yy*d;
        pz = zz*d;
    }

    public void calcParallelProjection(float  vp){
        if( z >= vp ){
            visible = false;
        }
        else{
            visible = true;
        }
        px = x;
        py = y;
        pz = z;
    }
    
    public boolean in(int wind_minx, int wind_miny, 
                      int wind_maxx, int wind_maxy){
        return (   (px >= wind_minx) && (px <= wind_maxx)
                && (py >= wind_miny) && (py <= wind_maxy));
    }
    
}





